package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceIntervalDurationEnt;
import pps.core.space.entity.SpaceIntervalDurationView;
import pps.core.space.mapper.SpaceIntervalDurationMapper;
import pps.core.space.mapper.SpaceIntervalDurationViewMapper;
import pps.core.space.service.data.space_interval_duration.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceIntervalDurationService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceIntervalDuration(XContext context, CreateSpaceIntervalDurationInput input) {
        SpaceIntervalDurationMapper mapper = context.getBean(SpaceIntervalDurationMapper.class);
        SpaceIntervalDurationEnt entity = new SpaceIntervalDurationEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceIntervalDuration(XContext context, UpdateSpaceIntervalDurationInput input) {
        SpaceIntervalDurationMapper mapper = context.getBean(SpaceIntervalDurationMapper.class);
        QueryWrapper<SpaceIntervalDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceIntervalDurationEnt::getId, input.getId());
        SpaceIntervalDurationEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceIntervalDuration(XContext context, DeleteSpaceIntervalDurationInput input) {
        SpaceIntervalDurationMapper mapper = context.getBean(SpaceIntervalDurationMapper.class);
        QueryWrapper<SpaceIntervalDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceIntervalDurationEnt::getId, input.getId());
        SpaceIntervalDurationEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceIntervalDurationOutput> getSpaceIntervalDuration(XContext context, GetSpaceIntervalDurationInput input) {
        SpaceIntervalDurationMapper mapper = context.getBean(SpaceIntervalDurationMapper.class);
        QueryWrapper<SpaceIntervalDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceIntervalDurationEnt::getId, input.getId());
        SpaceIntervalDurationEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceIntervalDurationOutput output = new GetSpaceIntervalDurationOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceIntervalDurationOutput> querySpaceIntervalDuration(XContext context, QuerySpaceIntervalDurationInput input) {
        SpaceIntervalDurationMapper mapper = context.getBean(SpaceIntervalDurationMapper.class);
        QueryWrapper<SpaceIntervalDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceIntervalDurationEnt::getId, input.getId())
                .eq(SpaceIntervalDurationEnt::getIsDeleted, input.getIsDeleted())
                .like(SpaceIntervalDurationEnt::getCreateById, input.getCreateById())
                .like(SpaceIntervalDurationEnt::getCreateByName, input.getCreateByName())
                .eq(SpaceIntervalDurationEnt::getCreateTime, input.getCreateTime())
                .like(SpaceIntervalDurationEnt::getModifyById, input.getModifyById())
                .like(SpaceIntervalDurationEnt::getModifyByName, input.getModifyByName())
                .eq(SpaceIntervalDurationEnt::getModifyTime, input.getModifyTime())
                .like(SpaceIntervalDurationEnt::getIntervalId, input.getIntervalId())
                .like(SpaceIntervalDurationEnt::getConfigId, input.getConfigId())
                .eq(SpaceIntervalDurationEnt::getOpenWellTime, input.getOpenWellTime())
                .eq(SpaceIntervalDurationEnt::getCloseWellTime, input.getCloseWellTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceIntervalDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceIntervalDurationOutput> dynamicQuerySpaceIntervalDuration(XContext context, CustomQueryInput input) {
        SpaceIntervalDurationMapper mapper = context.getBean(SpaceIntervalDurationMapper.class);
        return XMapperHelper.query(mapper, input, SpaceIntervalDurationEnt.class, QuerySpaceIntervalDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceIntervalDurationViewOutput> getSpaceIntervalDurationView(XContext context, GetSpaceIntervalDurationViewInput input) {
        SpaceIntervalDurationViewMapper mapper = context.getBean(SpaceIntervalDurationViewMapper.class);
        SpaceIntervalDurationView record = new SpaceIntervalDurationView();
        XCopyUtils.copyObject(input, record);
        SpaceIntervalDurationView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceIntervalDurationViewOutput output = new GetSpaceIntervalDurationViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceIntervalDurationViewOutput> querySpaceIntervalDurationView(XContext context, QuerySpaceIntervalDurationViewInput input) {
        SpaceIntervalDurationViewMapper mapper = context.getBean(SpaceIntervalDurationViewMapper.class);
        SpaceIntervalDurationView record = new SpaceIntervalDurationView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceIntervalDurationView> list = mapper.selectList(record);
        PageInfo<SpaceIntervalDurationView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceIntervalDurationViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceIntervalDurationViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
