package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceIntervalWellheadConfigEnt;
import pps.core.space.entity.SpaceIntervalWellheadConfigView;
import pps.core.space.mapper.SpaceIntervalWellheadConfigMapper;
import pps.core.space.mapper.SpaceIntervalWellheadConfigViewMapper;
import pps.core.space.service.data.space_interval_wellhead_config.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceIntervalWellheadConfigService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceIntervalWellheadConfig(XContext context, CreateSpaceIntervalWellheadConfigInput input) {
        SpaceIntervalWellheadConfigMapper mapper = context.getBean(SpaceIntervalWellheadConfigMapper.class);
        SpaceIntervalWellheadConfigEnt entity = new SpaceIntervalWellheadConfigEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceIntervalWellheadConfig(XContext context, UpdateSpaceIntervalWellheadConfigInput input) {
        SpaceIntervalWellheadConfigMapper mapper = context.getBean(SpaceIntervalWellheadConfigMapper.class);
        QueryWrapper<SpaceIntervalWellheadConfigEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceIntervalWellheadConfigEnt::getId, input.getId());
        SpaceIntervalWellheadConfigEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceIntervalWellheadConfig(XContext context, DeleteSpaceIntervalWellheadConfigInput input) {
        SpaceIntervalWellheadConfigMapper mapper = context.getBean(SpaceIntervalWellheadConfigMapper.class);
        QueryWrapper<SpaceIntervalWellheadConfigEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceIntervalWellheadConfigEnt::getId, input.getId());
        SpaceIntervalWellheadConfigEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceIntervalWellheadConfigOutput> getSpaceIntervalWellheadConfig(XContext context, GetSpaceIntervalWellheadConfigInput input) {
        SpaceIntervalWellheadConfigMapper mapper = context.getBean(SpaceIntervalWellheadConfigMapper.class);
        QueryWrapper<SpaceIntervalWellheadConfigEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceIntervalWellheadConfigEnt::getId, input.getId());
        SpaceIntervalWellheadConfigEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceIntervalWellheadConfigOutput output = new GetSpaceIntervalWellheadConfigOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceIntervalWellheadConfigOutput> querySpaceIntervalWellheadConfig(XContext context, QuerySpaceIntervalWellheadConfigInput input) {
        SpaceIntervalWellheadConfigMapper mapper = context.getBean(SpaceIntervalWellheadConfigMapper.class);
        QueryWrapper<SpaceIntervalWellheadConfigEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceIntervalWellheadConfigEnt::getId, input.getId())
                .eq(SpaceIntervalWellheadConfigEnt::getIsDeleted, input.getIsDeleted())
                .like(SpaceIntervalWellheadConfigEnt::getCreateById, input.getCreateById())
                .like(SpaceIntervalWellheadConfigEnt::getCreateByName, input.getCreateByName())
                .eq(SpaceIntervalWellheadConfigEnt::getCreateTime, input.getCreateTime())
                .like(SpaceIntervalWellheadConfigEnt::getModifyById, input.getModifyById())
                .like(SpaceIntervalWellheadConfigEnt::getModifyByName, input.getModifyByName())
                .eq(SpaceIntervalWellheadConfigEnt::getModifyTime, input.getModifyTime())
                .like(SpaceIntervalWellheadConfigEnt::getIntervalId, input.getIntervalId())
                .like(SpaceIntervalWellheadConfigEnt::getWellNumber, input.getWellNumber())
                .like(SpaceIntervalWellheadConfigEnt::getWellheadId, input.getWellheadId())
                .like(SpaceIntervalWellheadConfigEnt::getRunTypeKey, input.getRunTypeKey())
                .like(SpaceIntervalWellheadConfigEnt::getIntervalTypeKey, input.getIntervalTypeKey())
                .like(SpaceIntervalWellheadConfigEnt::getIntervalDescribe, input.getIntervalDescribe())
                .eq(SpaceIntervalWellheadConfigEnt::getOpenWellDay, input.getOpenWellDay())
                .eq(SpaceIntervalWellheadConfigEnt::getCloseWellDay, input.getCloseWellDay())
                .eq(SpaceIntervalWellheadConfigEnt::getRunDuration, input.getRunDuration());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceIntervalWellheadConfigOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceIntervalWellheadConfigOutput> dynamicQuerySpaceIntervalWellheadConfig(XContext context, CustomQueryInput input) {
        SpaceIntervalWellheadConfigMapper mapper = context.getBean(SpaceIntervalWellheadConfigMapper.class);
        return XMapperHelper.query(mapper, input, SpaceIntervalWellheadConfigEnt.class, QuerySpaceIntervalWellheadConfigOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceIntervalWellheadConfigViewOutput> getSpaceIntervalWellheadConfigView(XContext context, GetSpaceIntervalWellheadConfigViewInput input) {
        SpaceIntervalWellheadConfigViewMapper mapper = context.getBean(SpaceIntervalWellheadConfigViewMapper.class);
        SpaceIntervalWellheadConfigView record = new SpaceIntervalWellheadConfigView();
        XCopyUtils.copyObject(input, record);
        SpaceIntervalWellheadConfigView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceIntervalWellheadConfigViewOutput output = new GetSpaceIntervalWellheadConfigViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceIntervalWellheadConfigViewOutput> querySpaceIntervalWellheadConfigView(XContext context, QuerySpaceIntervalWellheadConfigViewInput input) {
        SpaceIntervalWellheadConfigViewMapper mapper = context.getBean(SpaceIntervalWellheadConfigViewMapper.class);
        SpaceIntervalWellheadConfigView record = new SpaceIntervalWellheadConfigView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceIntervalWellheadConfigView> list = mapper.selectList(record);
        PageInfo<SpaceIntervalWellheadConfigView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceIntervalWellheadConfigViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceIntervalWellheadConfigViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
